import os
import hashlib
import csv

export_file_rel = "server2"

def normalize_paths(file_path, directory_name):
    
    current_dir = os.getcwd()
    export_file_dir = os.path.join(current_dir, directory_name)
    new_path = os.path.relpath(file_path, export_file_dir)


    new_path = new_path.replace("\\", "/")
    return new_path


def get_directory_contents(directory):
    contents = []
    file_hashes = []
    for root, dirs, files in os.walk(directory):
        for file in files:
            path = os.path.join(root, file)
            print("path: ", path)
            file_hash = calculate_file_hash(path)
            path = normalize_paths(path, export_file_rel)
            contents.append(path)
            
            file_hashes.append(file_hash)
        for folder in dirs:
            path = os.path.join(root, folder)
            path = normalize_paths(path, export_file_rel)
            contents.append(path)
            file_hashes.append('N/A')
    return contents,file_hashes

def calculate_file_hash(file_path):
    md5_hash = hashlib.md5()
    with open(file_path, "rb") as file:
        for chunk in iter(lambda: file.read(4096), b""):
            md5_hash.update(chunk)
    return md5_hash.hexdigest()

# Specify the directory path
directory_path = 'C:\\Users\\Aimagin\\Downloads\\file_sync\\server2'
# Specify the output csv file path
csv_file = 'C:\\Users\\Aimagin\\Downloads\\file_sync\\filepath_hash_info2.csv'

# Get the file and folder paths
all_paths,hash_vals = get_directory_contents(directory_path)

# Write the path and hash to the csv file
with open(csv_file, 'w', newline='') as file:
    writer = csv.writer(file)
    # Write the header row
    writer.writerow(['path', 'hash'])
    for path, hashes in zip(all_paths, hash_vals):
        writer.writerow([path, hashes])